/*
 * Copyright (C) 2022, KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * Authors: iaom <zhangpengfei@kylinos.cn>
 *
 */
#ifndef OCROBJECT_H
#define OCROBJECT_H

#include <QObject>
#include <mutex>
#include <tesseract/baseapi.h>
#include <leptonica/allheaders.h>
#include <QDebug>

using namespace std;
class OcrObject : public QObject
{
    Q_OBJECT
public:
    static OcrObject* getInstance();

    void getTxtContent(QString &path, QString &textcontent);

protected:
    explicit OcrObject(QObject *parent = nullptr);
    ~OcrObject();

private:
    static OcrObject *m_instance;

    tesseract::TessBaseAPI  *m_api = nullptr;
    void init();

    class Garbo
    {
    public:
        ~Garbo() {
            if (OcrObject::m_instance)
                delete OcrObject::m_instance;
        }
        static Garbo g_garbo;
    };

};

#endif // OCROBJECT_H
